/***************************
	hashdb.h
		2013.8.19
		by H.Nakano

**************************/
#ifndef __HASHDB_H
#define __HASHDB_H

#define MaxCache 		512
#define topSize 		256
#define ip4addrLen 	16
#define PathMax  		256

#define TcpPort	"12350"

#define BlackPart 2
#define BlackON   1
#define BlackOFF  0

#define Check_OK   2
#define Check_Fail 3
#define Result_OK   "ok"
#define Result_Fail "failed"
#define Result_NoData 	"non_data"
#define Result_Blacked   "blacklisted"
#define Result_NoBlack   "non_black"
#define Result_Partial   "included_blacked"

#define BLK_CHECK 	0x01 		/* check only */
#define BLK_ADD   	0x01 << 1	/* add only   */
#define BLK_CHkADD 	0x01 << 2  /* check and add */
#define BLK_DEL   	0x01 << 3
#define BLK_LIST  	0x01 << 4
#define BLK_SUM   	0x01 << 5
#define BLK_SAVE  	0x01 << 6
#define BLK_LOAD  	0x01 << 7
#define BLK_CLEAN 	0x01 << 8
#define BLK_KILL  	0x01 << 10
#define BLK_ALL   	0xFFFF

#define HOST_Len    128
#define PASSWD_Len  32
#define BACKLOG 6

typedef struct arg_buff {
	int  		status;
	int 		flag;
	uint32_t   qnum;
	uint32_t	num; 
	int			range;
} arg_buff_t;

typedef struct ipaddr_range {
	uint32_t num;
	int 	range;
} ipaddr_range_t;

typedef struct allowed_host {
	char 	addr[ip4addrLen];
	char 	passwd[PASSWD_Len];
	int  	access;
} allowed_host_t;

typedef struct tcp_data {
	int  	flag;
	char 	host[HOST_Len];
	char 	passwd[PASSWD_Len];
	int	 	top;
	int	  	size;
	void 	*data;
} tcp_data_t;

typedef struct net_access {
	int  	   flag;
	char 		passwd[PASSWD_Len];
	int 		top;
	uint32_t	num;
	int 		range;
	int 		size;
} net_access_t;

#endif

