/************************
  	check_ksupport.c
		2013.9.4
		By H.Nakano

****************************/
#include <sys/utsname.h>

static int get_kernel_release(int rel[]){
	struct utsname buf;
	if (uname(&buf) != 0)
		return -1;

	char *dat = buf.release;
	for(;*dat != '.'; dat++){
		rel[0] = rel[0]*10 + (*dat - '0');
	} 
	dat++;
	for(;*dat != '-' && *dat != '.'; dat++){
		rel[1] = rel[1]*10 + (*dat - '0');
	} 
	dat++;
	for(;*dat != '-' && *dat != '.'; dat++){
		rel[2] = rel[2]*10 + (*dat - '0');
	} 
	return 0;
}

int check_ksupport(int m,int s,int u){
	int  rel[3] = {0,0,0};

	if (get_kernel_release(rel) < 0)
		return -1;

	if (rel[0] > m) 
		return 1;
	if (rel[0] == m){
		if (rel[1] > s) 
			return 1;
		if (rel[1] == s && rel[2] >= u)
			return 1;
	 }
	return -1;
}

