/*****************
	check_ports.c
		2013.9.13
		By H.Nakano

************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>

#include <glib.h>

typedef struct {
	int start;
	int end;
} port_range_t;

int get_tokennum(char *tokens){
		if (tokens == NULL)
			return -1;
		if (*tokens == '0')
			return  0;
		else{
			int num = atoi(tokens);
			if (num > 0 && num <= 65535)
				return num;
			else 
				return -1; 
		}
}

int check_ports(int num,int *val){
	for(int i=0; i< num;i++){
		if (val[i] <= 0 || val[i] >= 65536)
			return -1;
	 }
	return num;
}

int split_range(char *dat,port_range_t *rr){

	if (dat[0] == ':'){
		rr->start = 1;
		rr->end = atoi(&dat[1]);
		if (rr->start >=1 && rr->end <= 65535)
			return 0;
		else
			return -11;
	} else if (dat[strlen(dat) -1] == ':'){
		char aa[8];
		strncpy(aa,dat,strlen(dat) -1);
		rr->start = atoi(aa);
		rr->end = 65535;
		if (rr->start >=1 && rr->end <= 65535)
			return 0;
		else
			return -11;
	} else {
		gchar **tt = g_strsplit(dat,"-",2);
		if (tt[1] == NULL)
			return -1;
		rr->start = atoi(tt[0]);
		rr->end = atoi(tt[1]);
		g_strfreev(tt);
		if (rr->start >=1 && rr->end <= 65535)
			return 0;

		if (rr->start == 0 || rr->end == 0)
			return -11;
	}
	
	return -1;
}

#define MM_Range 36

port_range_t *check_port_range(char *dat){
	int ret = 0;
	int num = 1;
	int i,ss;
	port_range_t *rr = (port_range_t *)malloc(MM_Range*sizeof(port_range_t));

	gchar **tt = g_strsplit(dat,",",0);
	for(i=0; tt[i] != 0 ;i++){
		if (i >= MM_Range*num){
			num ++;
			rr = realloc(rr,MM_Range*num*sizeof(port_range_t));
		 }
		
		ret = split_range(tt[i],&rr[i]);
		if (ret == -11)
			break;
		if (ret < 0){
			ss = atoi(tt[i]);
		  	if (ss >=1 && ss <= 65535 ) {
				rr->start = ss;
				rr->end = ss;
			 } else {
				ret = -1;
				break;
		 	}
	   	}
	 }

	rr[i].start = 0;

	g_strfreev(tt);
	if (ret <0){
		free(rr);
	  	return NULL;
	 }
	return rr;
}


