/************************
	socktools.c
		2013.9.6
		By H.Nakano
*************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <syslog.h>
#include <errno.h>

/* write_log.c */
extern void writelog(int prio,char *fmt, ...);

int send_big_data(int sockfd,char *buf,int size){
	int total = 0;
	int bytesleft = size;
	int n =0;
	
	errno = 0;
	while(total < size) {
		n = send(sockfd,(void *)(buf + total),bytesleft, 0);
		if (n == -1){
			writelog(LOG_ERR,"Error:tcp_server2.c send_big_data(%s)",strerror(errno));
			break; 
		 }
		total += n;
		bytesleft -= n;
	}
	return n;
}

int recv_big_data(int sockfd,char *buf,int size){
	int total = 0;
	int bytesleft = size;
	int n = 0;

	errno = 0;
	while(total < size) {
		n = recv(sockfd,buf + total,bytesleft, 0);
		if (n == -1){
			writelog(LOG_ERR,"Error:tcp_server2.c recv_big_data(%s)",strerror(errno));
			break; 
		 }
		total += n;
		bytesleft -= n;
	 }
	return n;
}

